SystemOrganization addCategory: #ConfigurationOfStashShell!

Object subclass: #ConfigurationOfStashShell
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfStashShell'!

!ConfigurationOfStashShell classSide methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 13:02'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfStashShell classSide methodsFor: 'development support' stamp: 'DaleHenrichs 12/9/2010 15:28'!
compareVersions
	"Compare the current #stable version to current #development version"

	"self compareVersions"

	<apiDocumentation>
	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) compareVersionsIn: self) explore
! !

!ConfigurationOfStashShell classSide methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 13:02'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfStashShell classSide methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 13:02'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfStashShell classSide methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 12/9/2010 15:17'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfStashShell classSide methodsFor: 'loading' stamp: 'DaleHenrichs 12/9/2010 15:17'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfStashShell classSide methodsFor: 'loading' stamp: 'DaleHenrichs 12/9/2010 15:17'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfStashShell classSide methodsFor: 'loading' stamp: 'DaleHenrichs 12/9/2010 15:17'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfStashShell classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:17'!
project

	^self new project! !

!ConfigurationOfStashShell classSide methodsFor: 'development support' stamp: 'DaleHenrichs 12/9/2010 15:27'!
saveModifiedPackagesAndConfiguration: commitMessage
	"Save modified mcz files, update and then save the configuration."

	"self saveModifiedPackagesAndConfiguration: '- fixed bug'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) saveModifiedPackagesAndConfigurationIn: self description: commitMessage! !

!ConfigurationOfStashShell classSide methodsFor: 'development support' stamp: 'DaleHenrichs 12/9/2010 15:28'!
updateToLatestPackageVersions: descriptionString
	"Updates mcz file versions in current version"

	"self updateToLatestPackageVersions: '- fixed a bug'"

	<apiDocumentation>
	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) updateToLatestPackageVersionsIn: self description: descriptionString) isEmpty
		ifTrue: [ self inform: 'All specs up to date' ]! !

!ConfigurationOfStashShell classSide methodsFor: 'development support' stamp: 'DaleHenrichs 12/9/2010 15:28'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfStashShell methodsFor: 'baselines' stamp: 'DaleHenrichs 12/11/2010 16:06'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://seaside.gemstone.com/ss/stash'.
		spec 
			package: 'PetitParser' with: [
				spec repository: 'http://source.lukas-renggli.ch/petit'];
			package: 'PetitTests' with: [
				spec 
					requires: 'PetitParser';
					repository: 'http://source.lukas-renggli.ch/petit'];
			package: 'StashShell-Core' with: [
				spec requires: 'PetitParser'];
			package: 'StashShell-MC' with: [
				spec requires: 'StashShell-Core' ];
			package: 'StashShell-NIX' with: [
				spec requires: 'StashShell-Core' ];
			package: 'StashShell-Pharo' with: [
				spec requires: #('StashShell-Core').];
			package: 'StashShell-Tests' with: [
				spec requires: #('StashShell-Core' 'PetitTests' 'StashShell-NIX' 'StashShell-MC'). ];
			yourself.
		spec 
			group: 'default' with: #('Core' 'Tests');
			group: 'Core' with: #('StashShell-Core' 'StashShell-Pharo' 'StashShell-NIX' 'StashShell-MC');
			group: 'Tests' with: #('StashShell-Tests' );
			yourself ].
! !

!ConfigurationOfStashShell methodsFor: 'symbolic versions' stamp: 'DaleHenrichs 12/9/2010 15:19'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfStashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:17'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfStashShell methodsFor: 'versions' stamp: 'DaleHenrichs 12/12/2010 09:39'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- implemented several builtin commands and tests (ls, help, mkdir)
- 16 run 16 passed
- add cd command
- handle paths
- better error handling
- absorb the commandshell morphic classes into Stash
- add repo/configs/pkgs devices (mountable)
- add repo/configs/pkgs devices (mountable)
- refactoring command execution to make it easier to generalize command execution'.
		spec author: 'DaleHenrichs'.
		spec timestamp: '12/12/2010 09:39'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.208';
			package: 'PetitTests' with: 'PetitTests-lr.26';
			package: 'StashShell-Core' with: 'StashShell-Core-DaleHenrichs.6';
			package: 'StashShell-MC' with: 'StashShell-MC-DaleHenrichs.1';
			package: 'StashShell-NIX' with: 'StashShell-NIX-DaleHenrichs.3';
			package: 'StashShell-Pharo' with: 'StashShell-Pharo-DaleHenrichs.3';
			package: 'StashShell-Tests' with: 'StashShell-Tests-DaleHenrichs.6'.].
! !
